<template>
  <div
    :class="[drawerLarge ? 'w-[344px]' : 'w-0 opacity-0', isMobile ? 'w-full top-0 h-full' : 'h-[calc(100vh-129px)] top-[129px] border-l border-[#767680] border-opacity-100']"
    class="fixed right-0 overflow-hidden flex flex-col transition-all"
  >
    <div
      class="flex pr-3 pt-3 pb-4 justify-center items-center self-stretch relative"
      :class="isInThread ? 'pl-1' : 'pl-6'"
    >
      <svn-pro-icon-button
        v-if="isInThread"
        variant="text"
        color="onSurfaceVariant"
        icon="custom:mingcute:arrow-left-line"
        @click="closeThread"
      />

      <div class="flex flex-1 items-start">
        <svn-pro-title h5 regular>
          {{ headerTitle }}
        </svn-pro-title>
      </div>

      <svn-pro-icon-button
        variant="text"
        color="onSurfaceVariant"
        icon="custom:mingcute:close-line"
        @click="closeDrawerAndThread"
      />
    </div>

    <div ref="scrollContainer" class="flex h-full w-full flex-col overflow-y-auto overflow-x-hidden">
      <div
        v-if="hasListData"
        ref="scrollContainer"
        class="flex px-5 pt-2 pb-6 gap-4 flex-col"
      >
        <slot name="list-data" />
      </div>

      <slot v-else name="empty-list" />
    </div>

    <!-- Input section -->
    <div class="w-full h-[80px] flex pl-4 py-3 pr-3 gap-2 items-center border-t border-borderColor border-opacity-100">
      <!-- Text area to add comment -->
      <v-text-field
        v-model="userComment"
        variant="outlined"
        class="flex-1"
        color="primary"
        hide-details="auto"
        :placeholder="('Add a comment')"
        @keydown="enterAddComment"
      />

      <!-- Submit comment button -->
      <svn-pro-icon-button
        variant="text"
        color="onSurfaceVariant"
        :disabled="!userComment?.length"
        icon="custom:mingcute:send-line"
        @click="isInThread ? addThreadComment() : addComment()"
      />
    </div>
  </div>
</template>

<script setup>
import { ref } from 'vue';

const props = defineProps({
  hasListData: { type: Boolean, default: false },
  headerTitle: { type: String, default: '' },
  isMobile: { type: Boolean, default: false },
  drawerLarge: { type: Boolean, default: false },
  selectedComment: { type: Object },
  isInThread: { type: Boolean, default: false },
})

const emit = defineEmits(['close-thread', 'add-comment-reply', 'add-comment-thread-reply', 'close-drawer', 'update:modelValue'])

const userComment = ref('');
const scrollContainer = ref(null)
const closeDrawerAndThread = () => {
  emit('close-drawer')
}

const closeThread = () => {
  emit('close-thread')
}

const addComment = () => {
  emit('add-comment-reply', userComment?.value)
  userComment.value = null
}

const enterAddComment = (e) => {
  if (e.key === "Enter") {
    props.isInThread ? addThreadComment() : addComment()
    userComment.value = ''
  }
}

const addThreadComment = () => {
  emit('add-comment-thread-reply', {
    messageable_id: props.selectedComment?.messageable_id,
    reaction_type: "",
    comment: userComment?.value,
    comment_id: props.selectedComment?.id
  })
  userComment.value = null
}

defineExpose({
  scrollContainer
})
</script>